#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *unlig[256];

void init_unlig()
{
    unlig[ 16] = "__";
    unlig[ 17] = "='";
    unlig[ 18] = "=`";
    unlig[ 19] = "^";
    unlig[ 20] = "\"";
    unlig[ 21] = "\\";
    unlig[ 22] = "~";
    unlig[ 23] = "=";
    unlig[ 24] = "'";
    unlig[ 25] = "`";
    unlig[ 26] = "\\";
    unlig[ 27] = "\\";
    unlig[ 28] = "\\";
    unlig[ 29] = "\\";
    unlig[ 30] = "\\";
    unlig[ 31] = "__";
    unlig[ 35] = "j";
    unlig[ 37] = "W=";
    unlig[ 71] = "W\\";
    unlig[ 75] = "_";
    unlig[ 76] = "I=";
    unlig[ 78] = "I='";
    unlig[ 81] = "_";
    unlig[ 98] = "I=`";
    unlig[101] = "{_}";
    unlig[107] = "_";
    unlig[108] = "I^";
    unlig[110] = "I'";
    unlig[113] = "_";
    unlig[116] = "I`";
    unlig[125] = "JA";
    unlig[127] = "=";
    unlig[128] = "=`";
    unlig[129] = "=`";
    unlig[130] = "=`";
    unlig[131] = "=`";
    unlig[132] = "=`";
    unlig[133] = "JA=`";
    unlig[134] = "=`";
    unlig[135] = "'";
    unlig[136] = "j`";
    unlig[137] = "j^";
    unlig[142] = "W='";
    unlig[143] = "";
    unlig[144] = "W=`";
    unlig[145] = "_w";
    unlig[146] = "_W";
    unlig[147] = "i=`";
    unlig[148] = "i='";
    unlig[149] = "i^";
    unlig[150] = "i=";
    unlig[151] = "i`";
    unlig[153] = "_";
    unlig[155] = "_";
    unlig[156] = "_";
    unlig[160] = "_";
    unlig[161] = "\\";
    unlig[162] = "\\";
    unlig[163] = "\\";
    unlig[164] = "\\";
    unlig[165] = "\\";
    unlig[166] = "\\";
    unlig[167] = "\\";
    unlig[168] = "w\\";
    unlig[169] = "_";
    unlig[170] = "i'";
    unlig[171] = "";
    unlig[172] = "='";
    unlig[173] = "=`";
    unlig[176] = "=";
    unlig[177] = "=";
    unlig[178] = "=";
    unlig[179] = "=";
    unlig[180] = "=";
    unlig[181] = "JA=";
    unlig[182] = "=";
    unlig[183] = "='";
    unlig[184] = "='";
    unlig[185] = "='";
    unlig[186] = "='";
    unlig[187] = "='";
    unlig[188] = "='";
    unlig[189] = "JA='";
    unlig[190] = "='";
    unlig[191] = "=`";
    unlig[253] = "j";
}

int reduce_ch(int ch_code, char *dst_buf)
{
    int l;
    char *res;

    switch(ch_code)
    {
      case '.':
      case ',':
      case ':':
      case ';':
      case '!':
	return 0;
    }

    res = unlig[ch_code];
    if(res != NULL)
    {
	l = strlen(res);
	strcpy(dst_buf, res);
    }
    else
    {
	l = 1;
        dst_buf[0] = ch_code;
	dst_buf[1] = 0;
    }
    return l;
}

int main(int argc, char *argv[])
{
    int i;
    int l;
    int ch;
    FILE *fi;
    FILE *fo;
    const int BUFSIZE = 1023;
    const int MAXWORDS = 1024;
    char cmdline[BUFSIZE+1];
    char jobname[BUFSIZE+1];
    int startpage;
    int nwords;
    int cur_page;
    int cur_nrules;
    char *words[MAXWORDS];

    const char *bpage = "beginning of page";
    const char *catchw = "xxx 'catchword'";
    const int lnbpage = strlen(bpage);
    const int lncatchw = strlen(catchw);

    init_unlig();

    if(argc < 2)
    {
	fprintf(stderr, "Usage: mkfwp dvi_file_name_without_ext[.dvi]\n");
	return 1;
    }

    strncpy(jobname, argv[1], BUFSIZE);
    jobname[BUFSIZE] = 0;
    l = strlen(jobname);
    printf("%s\n", jobname+l-4);
    if(strncasecmp(jobname+l-4, ".dvi", 4) == 0)
    {
	jobname[l-4] = 0;
	printf("JOBNAME: %s\n", jobname);
    }

    sprintf(cmdline, "dvitype %s.dvi", jobname);
    
    fi = popen(cmdline, "r");

    cur_page = 0;
    startpage = 0;
    nwords = 0;
    while(1)
    {
	char line[BUFSIZE+1];
	char cur_word[BUFSIZE+1];
	char *wordp;
	char *res;
	int ndig, found_col;
	char *p;

	if(feof(fi))
	    break;
	res = fgets(line, BUFSIZE, fi);
	if(res == NULL)
	    break;
	line[BUFSIZE] = 0;
	// printf("%s", line);

	ndig = 0;
	
	for(p = res; *p; p++)
	    if(isdigit(*p))
		ndig++;
	    else if(*p == ':')
	    {
		found_col = 1;
		break;
	    }
	if(!found_col || ndig == 0)
	    continue;
	p += 2;
	// printf(p);

	res = strstr(p, bpage);
	if(res)
	{
	    cur_page = atoi(res+lnbpage);
	    printf("NEW PAGE: %d\n", cur_page);
	    cur_nrules = 0;
	    startpage = 0;
	    wordp = cur_word;
	    continue;
	}

	if(startpage == 0 && strncmp(p, catchw, lncatchw) == 0)
	    startpage = 1;

        if(startpage == 1)
	{
	    if(strncmp(p, "set1", 4) == 0)
	    {
                ch = atoi(p+4);
		l = reduce_ch(ch, wordp);
		wordp += l;
	    }
            else if(strncmp(p, "setchar", 7) == 0)
	    {
		ch = atoi(p+7);
		l = reduce_ch(ch, wordp);
		wordp += l;
	    }
	    else
	    {
		int m = p[0] == 'w';
		int n = strncmp(p, "right3", 6) == 0;
		int k = strncmp(p, "z3", 2) == 0;
		int j = strncmp(p, "down3", 5) == 0;
		if((m || k || j || (n &&  atoi(p+6) > 0)) && wordp != cur_word)
		{
		    startpage = 0;
		    // *wordp = 0;
		    printf("FOUND WORD: %s\n", cur_word);
		    p = (char *)calloc(1, strlen(cur_word)+1);
		    strcpy(p, cur_word);
		    words[nwords++] = p;
		}
	    }
	}
    }


    sprintf(cmdline, "%s.fwp", jobname);
    fo = fopen(cmdline, "wt");

    for(i=1; i<nwords; i++)
	fprintf(fo, "%s%%\n", words[i]);

    fclose(fo);

    return 0;
}
